<div class="taxonomy-container">
    <div class="filter-container">
      <mat-form-field class="filter-field">
        <input matInput placeholder="Filter" (keyup)="applyFilter()" [(ngModel)]="filterString" />
      </mat-form-field>
      <div class="control-buttons">
        <button mat-button (click)="expandAll()">Expand All</button>
        <button mat-button (click)="collapseAll()">Collapse All</button>
      </div>
    </div>
  
    <div class="header-row">
      <span class="name">Name</span>
      <span>Quantifications</span>
    </div>
  
    <cdk-tree [dataSource]="dataSource" [treeControl]="treeControl" class="taxonomy-tree">
      <!-- Leaf Node -->
      <cdk-tree-node
        *cdkTreeNodeDef="let node"
        cdkTreeNodeToggle
        cdkTreeNodePadding
        [cdkTreeNodePaddingIndent]="calculateEffectiveIndent(node)"
        (click)="clickNode(node)"
        class="taxonomy-node"
        [class.taxonomy-node-highlighted]="isHighlightedNode(node)"
        [ngStyle]="{ display: shouldRenderNode(node) ? 'flex' : 'none' }">
        <div class="node-row">
          <div class="node-left">
            <span class="node-name">{{ node.scientificname }}</span>
          </div>
          <div class="node-details">
            <span class="node-quantifications">{{ node.quantifications }}</span>
            <mat-checkbox [(ngModel)]="node.isSelected"></mat-checkbox>
          </div>
        </div>
      </cdk-tree-node>
  
      <!-- Expandable Node -->
      <cdk-tree-node
        *cdkTreeNodeDef="let node; when: hasChild"
        cdkTreeNodeToggle
        cdkTreeNodePadding
        [cdkTreeNodePaddingIndent]="calculateEffectiveIndent(node)"
        (click)="clickNode(node)"
        (dblclick)="dblClickNode(node)"
        class="taxonomy-node"
        [class.taxonomy-node-highlighted]="isHighlightedNode(node)"
        [ngStyle]="{ display: shouldRenderNode(node) ? 'flex' : 'none' }">
        <div class="node-row">
          <div class="node-left">
            <mat-icon class="mat-icon-rtl-mirror" (click)="dblClickNode(node)">
              {{ node.isExpanded ? 'expand_more' : 'chevron_right' }}
            </mat-icon>
            <span class="node-name">{{ node.scientificname }}</span>
          </div>
          <div class="node-details">
            <span class="node-quantifications">{{ node.quantifications }}</span>
            <mat-checkbox [(ngModel)]="node.isSelected"></mat-checkbox>
          </div>
        </div>
      </cdk-tree-node>
    </cdk-tree>
  </div>
  